<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- @author Dmitry Repchevsky -->

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:c="http://xmlns.jcp.org/jsp/jstl/core"
      xmlns:fn="http://xmlns.jcp.org/jsp/jstl/functions"
      xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
      xmlns:x="http://xmlns.jcp.org/jsf/composite/components">
    
    <body>
      <ui:composition>
        <c:forEach items="#{result}" var="entry">
          <c:choose>
            <c:when test="#{entry.value.getClass().getSimpleName() eq 'HashMap'}">
              <x:toggle collapsedHeaderClass="tree-map-header collapsed" expandedHeaderClass="tree-map-header expanded">
                <f:facet name="header">
                  <h:outputText value="#{entry.key}"/>
                </f:facet>
                <f:facet name="content">
                  <div class="tree-map-content">
                    <ui:include src="tree.xhtml">
                      <ui:param name="result" value="#{entry.value}" />
                    </ui:include>
                  </div>
                </f:facet>
              </x:toggle>
            </c:when>
            <c:when test="#{entry.value.getClass().getSimpleName() eq 'ArrayList'}">
              <x:toggle collapsedHeaderClass="tree-map-header collapsed" expandedHeaderClass="tree-map-header expanded">
                <f:facet name="header">
                  <h:outputText value="#{entry.key}" />
                </f:facet>
                <f:facet name="content">
                  <div class="tree-map-content">
                    <c:forEach items="#{entry.value}" var="element">
                      <c:choose>
                        <c:when test="#{element.getClass().getSimpleName() eq 'HashMap'}">
                          <ui:include src="tree.xhtml">
                            <ui:param name="result" value="#{element}" />
                          </ui:include>
                        </c:when>
                        <c:otherwise>
                          <h:outputText class="tree-property" value="#{element}" />
                        </c:otherwise>
                      </c:choose>
                    </c:forEach>
                  </div>
                </f:facet>
              </x:toggle>
            </c:when>
            <c:otherwise>
              <div class="tree-property">
                <h:outputText class="tree-property-name" value="#{entry.key}: " />
                <h:outputText class="tree-property-value" value="#{entry.value}" />
              </div>
            </c:otherwise>
          </c:choose>
        </c:forEach>
      </ui:composition>
    </body>
</html>
